
call SetFrameRate(100)

call IntensitySprite(100)
textSize = {40, 5}
call TextSizeSprite(textSize)

version = Version()

' If the user has version 1.00
if version = 100 then

    instructions = {{-80, 90, "YOU HAVE VECTREX32 1.00."}, _
                    {-80, 70, "TO UPGRADE, GO TO"}, _
                    {-80, 60, "VECTREX32.COM AND"}, _
                    {-80, 50, "CONTACT US"}}

    call TextListSprite(instructions)

    ' Do forever
    while true
        call WaitForFrame(JoystickNone, Controller1, JoystickNone)
    endwhile

else

    versionNumber = version / 100 + "." + TwoDigits(version mod 100)
    newVersion = ""
    files = Dir()
    for i = 1 to UBound(files)
        if StrComp(".v32", Right(files[i], 4), 1) = 0 then
            newVersion = Mid(files[i], 11, 4)
            exit for
        endif
    next i

    done = false
    
    if newVersion = "" then
    
        instructions = {{-80, 90, "CAN'T FIND A .V32"}, {-80, 80, "UPGRADE FILE."}}
        done = true
        
    else
    
        instructions = {{-80, 90, "YOU HAVE VECTREX32 " + versionNumber + "."}, _
                        {-80, 70, "TO UPGRADE TO " + newVersion + ","}, _
                        {-80, 60, "PRESS BUTTON 1."}, _
                        {-80, 50, "THE SCREEN WILL GO"}, _
                        {-80, 40, "BLACK FOR UP TO 15"}, _
                        {-80, 30, "SECONDS. PLEASE WAIT."}}
    endif

    sprite = TextListSprite(instructions)

    ' Do forever
    while true
        ' Get the current control state
        controls = WaitForFrame(JoystickNone, Controller1, JoystickNone)
        
        if controls[1, 3] and not done then
            call Upgrade(1)
            call RemoveSprite(sprite)
            instructions = {{-80, 90, "UPGRADE COMPLETE!"}, _
                            {-80, 70, "TURN THE VECTREX"}, _
                            {-80, 60, "OFF AND ON."}}
            sprite = TextListSprite(instructions)
        endif
        
    endwhile
    
endif

function TwoDigits(x)
    if x < 10 then
        return "0" + x
    else
        return "" + x
    endif
endfunction
